/*
* ################################################################
*
* ProActive: The Java(TM) library for Parallel, Distributed,
*            Concurrent computing with Security and Mobility
*
* Copyright (C) 1997-2002 INRIA/University of Nice-Sophia Antipolis
* Contact: proactive-support@inria.fr
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*
*  Initial developer(s):               The ProActive Team
*                        http://www.inria.fr/oasis/ProActive/contacts.html
*  Contributor(s):
*
* ################################################################
*/
package org.objectweb.proactive.core.body.rmi;

import org.apache.log4j.Logger;
import org.objectweb.proactive.core.ProActiveException;
import org.objectweb.proactive.core.ProActiveRuntimeException;
import org.objectweb.proactive.core.body.ProActiveMetaObjectFactory;
import org.objectweb.proactive.core.body.RemoteBodyFactory;
import org.objectweb.proactive.core.body.UniversalBody;

public class ProActiveRmiMetaObjectFactory extends ProActiveMetaObjectFactory implements  java.io.Serializable {

protected static Logger logger = Logger.getLogger(ProActiveRmiMetaObjectFactory.class.getName());


  //
  // -- PROTECTED MEMBERS -----------------------------------------------
  //


  

  protected RemoteBodyFactory newRemoteBodyFactorySingleton() {
    return new RemoteRmiBodyFactoryImpl();
  }






  //
  // -- INNER CLASSES -----------------------------------------------
  //



  protected static class RemoteRmiBodyFactoryImpl implements RemoteBodyFactory, java.io.Serializable {
    public UniversalBody newRemoteBody(UniversalBody body) {
      try {
          return new org.objectweb.proactive.core.body.rmi.RemoteBodyAdapter(body);
      } catch (ProActiveException e) {
          throw new ProActiveRuntimeException("Cannot create Remote body adapter ", e);
      }
    }
  } // end inner class RemoteBodyFactoryImpl




}
